<?php

namespace Drupal\campaignmonitor\Plugin\Block;

use Drupal\Core\Block\BlockPluginInterface;
use Drupal\Core\Block\BlockBase;

/**
 * Provides a 'Campaign' block.
 *
 * @Block(
 *   id = "campaignmonitor_campaign_block",
 *   admin_label = @Translation("Campaign Block"),
 *   category = @Translation("Campaign Monitor Campaigns"),
 *   module = "campaignmonitor",
 * )
 */
class CampaignMonitorCampaignBlock extends BlockBase implements BlockPluginInterface {

  /**
   * {@inheritdoc}
   */
  public function build() {

    $config = $this->getConfiguration();

    $campaigns = campaignmonitor_get_campaigns();

    if ($campaigns) {
      $content = '<ul>';
      foreach ($campaigns as $campaign) {
        $content .= '<li>' . l($campaign['Name'], $campaign['Link']) . ' ' . format_date($campaign['Sent'], 'short') . '</li>';
      }
      $content .= '</ul>';

      // Build block.
      $block['subject'] = t('Newsletter archive');
      $block['content'] = ['#markup' => $content];
    }
    else {
      drupal_set_message(t('Unable to fetch campaigns from Campaign monitor.'), 'error');
    }
    return $block['content'];
  }

}
